// Copyright (C) 2018 Marius Schellenberger

package jwt

import "sync"

// Blacklist is the blacklisting storage interface
type Blacklist interface {
	Add(string, int64)
	Remove(string)
	Check(string) bool
	Map() BlacklistMap
}

// BlacklistMap is the blacklist map structure
type BlacklistMap map[string]int64

// MemBlacklist implements the Blacklist interface
type MemBlacklist struct {
	// protects list
	sync.RWMutex
	list BlacklistMap
}

// NewMemBlacklist implements the Blacklist interface using an in-memory map
func NewMemBlacklist() *MemBlacklist {
	return &MemBlacklist{list: make(BlacklistMap)}
}

// Add adds a new token signature with expiration time to the blacklist
func (mb *MemBlacklist) Add(sig string, exp int64) {
	mb.Lock()
	mb.list[sig] = exp
	mb.Unlock()
}

// Remove deletes a token signature from the blacklist
func (mb *MemBlacklist) Remove(sig string) {
	mb.Lock()
	delete(mb.list, sig)
	mb.Unlock()
}

// Check returns true if a token signature is blacklisted and false otherwise
func (mb *MemBlacklist) Check(sig string) (ok bool) {
	mb.RLock()
	_, ok = mb.list[sig]
	mb.RUnlock()
	return
}

// Map returns the blacklist in the form of a iterable map structure for cleanup
func (mb *MemBlacklist) Map() (list BlacklistMap) {
	list = make(BlacklistMap)
	mb.RLock()
	for k, v := range mb.list {
		list[k] = v
	}
	mb.RUnlock()
	return
}
